#include <vector>
#include <string>
#include <iostream>
#include <cmath>
#include <cctype>
#include <sstream>
#include <algorithm>
#include <iomanip>

using namespace std;

typedef long double real;
typedef long long TT;

#define PB push_back
#define SQR(x) ((x)*(x))
#define PII pair<int, int>
#define VI vector<int>
#define VVI vector<VI >
#define VS vector<string>
#define VTT vector<TT>
#define VR vector<real>
#define A first
#define B second

const int MinN = 1;
const int MaxN = 100000;
const int MinM = 1;
const int MaxM = 100000;

int test = 3;
int a[MaxN+1];
VI q;

int random(int l, int r)
{
   int x = (rand()%1000) * (rand()%100) + rand();
   return (x % (r-l+1)) + l;
}

void shuffle(int n)
{
   int i;
   for (i = 1; i <= n; i++) a[i] = i;
   for (i = 1; i <= 5*n; i++) {
      int j = random(1, n), k = random(1, n);
      swap(a[j], a[k]);
   }
}

void genrandom(int n, int m)
{
   shuffle(n);
   q.clear();
   for (int i = 0; i < m; i++) {
      int x = random(1, n);
      int y = random(1, n);
      if (x > y) swap(x, y);
      int k = random(1, n);
      int l = random(1, n);
      if (k > l) swap(k, l);
      q.PB(x); q.PB(y); q.PB(k); q.PB(l);
   }
}

void genmax(int n, int m, int d)
{
   shuffle(n);
   q.clear();
   for (int i = 0; i < m; i++) {
      int x = random(1, d);
      int y = random(n-d+1, n);
      int k = random(1, d);
      int l = random(n-d+1, n);
      q.PB(x); q.PB(y); q.PB(k); q.PB(l);
   }
}

void out(int n, int m)
{
   int i, j;

   test++;
   ostringstream ss; ss << test/10 << test%10;   
   freopen(ss.str().c_str(),"wt",stdout);

   cout << n << " " << m << endl;
   for (i = 1; i <= n; i++) cout << a[i] << " ";
   cout << endl;
   for (i = 0; i < m; i++) {
      for (j = 0; j < 4; j++) cout << q[i*4 + j] << " ";
      cout << endl;
   }

   fclose(stdout);
}

int main()
{
   srand(11238);

   genrandom(1000, 30000); out(1000, 30000);
   genrandom(30000, 1000); out(30000, 1000);

   genrandom(30000, 30000); out(30000, 30000);
   genrandom(40000, 40000); out(40000, 40000);
   genrandom(50000, 50000); out(50000, 50000);
   genrandom ( 60000,  60000); out(60000,  60000);
   genmax ( 70000,  70000, 5); out(70000,  70000);
   
/*   genrandom ( 70000, 100000); out( 70000, 100000);
   genrandom ( 80000, 100000); out( 80000, 100000);
   genrandom ( 90000, 100000); out( 90000, 100000);
   genrandom ( 95000, 100000); out( 95000, 100000);
   genrandom (100000, 100000); out(100000, 100000);
   
   genrandom (100000,  70000); out(100000,  70000);
   genrandom (100000,  80000); out(100000,  80000);
   genrandom (100000,  90000); out(100000,  90000);
   genrandom (100000,  95000); out(100000,  95000);
   genmax (100000, 100000, 15); out(100000, 100000);*/

   return 0;   
}